
#include	"nrs.h"

#define CTRL_C		0x03	// L[R[h
#define ESCAPE		0x1b	// L[R[h
#define	SIZE_COMBUF	256	// comfuncs.lib p
#define MAX_BAUD	11	// baud ̎ނ̌

//----------------------------------------------------------------------------
// class Com
//----------------------------------------------------------------------------

int	Com::Done = FALSE;
int	Com::MsgOff = FALSE;
UCHAR	Com::RBuf[ SIZE_COMBUF ];
UCHAR	Com::SBuf[ SIZE_COMBUF ];
Com	*Com::PtrCom;

COM_INIT_DATA
Com::Info = {
	8, SBuf, RBuf,
	SIZE_COMBUF, SIZE_COMBUF, 0x4e
};

void
Com::SetBaud( char *p )
{
	static long	bauds[ MAX_BAUD ] = {
		75, 150, 300, 600, 1200, 2400, 4800,
		9600, 19200, 38400, 76800
	};

	long	l;
	int	i;

	l = atol( p );
	for( i = 0; i < MAX_BAUD; i++ ){
		if( l == bauds[i] ) break;
	}

	if( i == MAX_BAUD ){
		printf( " [ Unknown Baud ] %s\n", p );
	} else {
		Info.baud = i;
		ComParam( 0, Info.baud, Info.command );

		printf( " Baud = %ld\n", l );
	}
}

void
Com::SetPara( char *p )
{
	int	i;

	sscanf( p, "%x", &i );
	i &= 0xfc; i |= 0x02;	// ʂQrbg 1 0

	Info.command = (UCHAR) i;
	ComParam( 0, Info.baud, Info.command );

	printf( " Com parameter = %02X\n", (UCHAR) i );
}

int
Com::CheckKey( void )
{
	if( ioctl( 0, 0x06 ) != 0 ){
		switch( getch() )
		{
		case ESCAPE:
			Putc( ERROR_CODE );
			break;

		case CTRL_C:
		case 'Q':
		case 'q':
			Done = TRUE;
		}
	}

	return Done;
}

UCHAR
Com::Getc( void )
{
	while( ComBufSt( 0 ) == 0 ){
		if( CheckKey() == TRUE ) break;
	}

	return ComRead( 0 );
}

void
Com::Putc( UCHAR c )
{
	while( ComSendBufSt( 0 ) != 0 ){
		if( CheckKey() == TRUE ) break;
	}
	if( Done == TRUE ) c = ERROR_CODE;

	ComSend( 0, c );
}

UINT
Com::Getw( void )
{
	UCHAR	c1 = Getc();
	UCHAR	c2 = Getc();

	return c1 + (c2 << 8);
}

void
Com::Putw( UINT i )
{
	Putc( (UCHAR) i );
	Putc( (UCHAR) (i >> 8) );
}

long
Com::Getp( void )
{
	long l1,l2;

	l1 = Getw();
	l2 = Getc();

	return l1 + (l2 << 16);
}

void
Com::Putp( long l )
{
	if( l > 0xffffffL ) l = 0xffffffL;

	Putw( (UINT) l );
	Putc( (UCHAR) (l >> 16) );
}

