#include  <stdio.h>
#include  <string.h>
#include  <fcntl.h>
#include  <unistd.h>
#include  <sys/ioctl.h>

#ifdef FBSD
#include  <sys/ioctl_compat.h>
#include  <sys/tty.h>
#endif

#ifdef LINUX
#include <termios.h>
#endif

#include  <sys/time.h>
#include  "com_func.h"

#define  PORT_NAME      "/dev/cuaa0"
#define  DEFAULT_BPS    19200
#define  TC_MAX_BAUDS   10
#define  RSLIB_MAX_BAUD 11


static int   fd;

#ifdef FBSD
struct termios org_tbuf;
struct termios tbuf;
#endif

#ifdef LINUX
struct termio org_tbuf;
struct termio tbuf;
#endif


extern "C"{

/*		QRQb̏  */
int	ComInit(int nazo, struct com_init_data *info)
{
/*	ftHg̐ݒŏ邾ł̂ȁH  */
	if(info->bits != 8){
		return !0;  /*  rbg 8 bit łȂƂ́As  */
	}

	if((fd = open(PORT_NAME, O_RDWR | O_NONBLOCK , 0)) == -1){
		return !0;
	}
	else{
/*  FreeBSD p̃[`͂܂  */
#ifdef FBSD
		if(ioctl(fd, TIOCGETA, &org_tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to get original value)\n");
			return !0;
		}

		if(ioctl(fd, TIOCGETA, &tbuf) == -1){
			fprintf(stderr,
					 "ioctl error! (in stage to get value for setting)\n");
			return !0;
		}

		tbuf.c_ispeed = DEFAULT_BPS;  /*  ftHg bps = 19200  */
		tbuf.c_ospeed = DEFAULT_BPS;  /*  ftHg bps = 19200  */
		tbuf.c_lflag = tbuf.c_lflag & ~ICANON;
/*		tbuf.c_lflag &= ~TOSTOP;  */
/*  Ȃ΃obNOEh삷H  */
		tbuf.c_cflag |= CLOCAL;

		if(ioctl(fd, TIOCSETA, &tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to set aplinks value)\n");
			return !0;
		}
#endif
/*  FreeBSD p̃[`  */

/*  Linux p̃[`͂܂  */
#ifdef LINUX
		if(ioctl(fd, TCGETA, &org_tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to get original value)\n");
			return !0;
		}

		if(ioctl(fd, TCGETA, &tbuf) == -1){
			fprintf(stderr,
					 "ioctl error! (in stage to get value for setting)\n");
			return !0;
		}

		tbuf.c_cflag |= DEFAULT_BPS;  /*  ftHg bps = 19200  */
#if 0
		tbuf.c_ospeed = DEFAULT_BPS;  /*  ftHg bps = 19200  */
#endif
		tbuf.c_lflag &= ~ICANON;
/*		tbuf.c_lflag &= ~TOSTOP;  */
/*  Ȃ΃obNOEh삷H  */
		tbuf.c_cflag |= CLOCAL;
		tbuf.c_cflag |= CS8;
		tbuf.c_cflag &= ~PARENB;
		tbuf.c_iflag &= ~INPCK;

		if(ioctl(fd, TCSETAW, &tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to set aplinks value)\n");
			return !0;
		}
#endif
/*  Linux p̃[`  */

		return 0;  /*    */
	}

/*	 0 ԂBs !0B  */

/*  ̐ݒ́AƂ肠AT{(^^;)  */
/*  stop bit 1  */    /*  Linux ł͐ݒ肵  */
/*  peB  */  /*  Linux ł͐ݒ肵  */ 
/*  X t[  */
/*  Mobt@TCY  */
/*  Mobt@ւ̃|C^  */
/*  Mobt@TCY  */
/*  Mobt@ւ̃|C^  */
}


/*		ʐMp[^̕ύX */
int	ComParam(int nazo1, int baud, unsigned char command)
{
	static long	rslib_bauds[ RSLIB_MAX_BAUD ] = {
		75, 150, 300, 600, 1200, 2400, 4800,
		9600, 19200, 38400L, 76800L
	};
	
/*	static long tc_bauds[TC_MAX_BAUDS] = {
	    75, 150, 300, 600, 1200, 2400, 4800, 9600, 19200, 38400L
	};  */
	
	
	if(command == 0x4e){	/*  {[[g̕ύX  */
/*  FreeBSD p̃[`͂܂  */
#ifdef FBSD
		tbuf.c_ispeed = rslib_bauds[baud];
		tbuf.c_ospeed = rslib_bauds[baud];
		if(ioctl(fd, TIOCSETA, &tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to set aplinks value)\n");
			return !0;  /*  s  */
		}
		else{
			return 0;  /*    */
		}
	}
#endif
/*  FreeBSD p̃[`  */

/*  Linux p̃[`͂܂  */
#ifdef LINUX
		tbuf.c_cflag |= rslib_bauds[baud];
/*		tbuf.c_ospeed = rslib_bauds[baud];  */
		if(ioctl(fd, TCSETAW, &tbuf) == -1){
			fprintf(stderr,
					  "ioctl error! (in stage to set aplinks value)\n");
			return !0;  /*  s  */
		}
		else{
			return 0;  /*    */
		}
	}
#endif
/*  Linux p̃[`  */

	else{
		printf("Sorry, I don't know \"commmand %x\".", command);
		return !0;
	}
}


/*		QRQb̎gpI */
void	ComRet(int nazo)
{
/*  FreeBSD p̃[`͂܂  */
#ifdef FBSD
	if(ioctl(fd, TIOCSETA, &org_tbuf) == -1){
		fprintf(stderr,
				  "ioctl error! (in stage to restore original value)\n");
	}
#endif
/*  FreeBSD p̃[`  */

/*  Linux p̃[`͂܂  */
#ifdef LINUX
	if(ioctl(fd, TCSETAW, &org_tbuf) == -1){
		fprintf(stderr,
				  "ioctl error! (in stage to restore original value)\n");
	}
#endif
/*  Linux p̃[`܂  */
	
	close(fd);
}


/*		QRQbPoCgǂ݂ */
unsigned char	ComRead(int nazo)
{
	unsigned char buf;
	
	read(fd, &buf, 1);

	return (unsigned char)buf;
}


/*		QRQbɂPoCgM */
unsigned char	ComSend(int nazo, unsigned char data)
{
	int retval;


	while(1){
		if((retval = write(fd, &data, 1)) != -1){
			break;
		}
	}

	return retval;
}


/*		Mobt@ɂ܂Ăf[^TCY擾 */
unsigned int	ComBufSt(int nazo)
{
	fd_set readfds;
	struct timeval timeout;

	
	FD_ZERO(&readfds);
	FD_SET(fd, &readfds);
/*	timeout.tv_sec = 1;
	timeout.tv_usec = 0;  */
	timeout.tv_sec = 0;
	timeout.tv_usec = 500;
	select(fd + 1, &readfds, NULL, NULL, &timeout);
	if(FD_ISSET(fd, &readfds)){
		return 1;
	}
	else{
		return 0;
	}
}


/*		Mobt@ɂ܂Ăf[^TCY擾 */
unsigned int	ComSendBufSt(int nazo)
{
/*	Ƃ肠A܂ĂȂƂɂB  */
	return 0;
}
}
