//----------------------------------------------------------------------------
// 97/09/10
// NRS: New Remote File System Server for PC-9801 series (Ver1.0)
// ( Tab size = 8 )
//----------------------------------------------------------------------------

#include	"nrs.h"

void	check_arg( int argc, char **argv );	// `FbN
void	mainloop( void );			// C[v
void	set_break( char c );			// <CTRL-C> Xe[^X̐ݒ
char	get_break( void );			// <CTRL-C> Xe[^X̎擾


int
main( int argc, char **argv )
{
	char	my_path[ SIZE_PATH ];	// ÑJgfBNg
	char	stat_break;		// <CTRL-C> Xe[^X

	int	i;

	// ^Cg
	printf(
		"\n New Remote File System Server 'NRS' for PC-9801 series\n"
		"  Ver1.0 (c)1997 H.Yamashita(NIBIE)\n"
	);

	// gp@
	if( (argc == 2) && (argv[1][1] == '?') ){
		printf(
			"\n Usage: NRS"
			" [directory [directory [directory]]] [-option]\n\n"
			"  <option> (n = 10 i, x = 16 i)\n\n"

			"\t-Bn: ʐMx̐ݒ (default: n = 19200)\n"
			"\t\tn = 75, 150, 300, 600, 1200, 2400, 4800,\n"
			"\t\t    9600, 19200, 38400, 76800\n\n"

			"\t-Px: ʐMp[^̐ݒihLgQƁj"
			"(default: x = 4e)\n\n"

			"\t-Ax: t@C̑ (default: x = 33)\n"
			"\t\tbit0: Read only\t\tbit1: Hidden file\n"
			"\t\tbit2: System file\tbit3: Volume label\n"
			"\t\tbit4: Directory\t\tbit5: Archive\n\n"

			"\t-Fn: PhCũt@Cő吔 "
			"(default: n = 256)\n"
			"\t\tn = 1 ` 256\n\n"

			"\t-M: R}h}[N̕\}\n"
		);
		return 1;
	}

	// rs-232c hCo
	Com	MyCom;
	if( MyCom.GetDone() == TRUE ){
		printf( " Error: Can't initialize RS-232C port\n" );
		return 1;
	}

	// JgfBNg擾
	getcwd( my_path, SIZE_PATH );

	// e[ũm
	Table	MyTable[ MAX_DRIVE ];
	for( i = 0; i < MAX_DRIVE; i++ ){
		strcpy( MyTable[ i ].GetPath(), my_path );

		if( MyTable[ i ].GetErrorNew() == TRUE ){
			printf( " Error: Memory not enough\n" );
			return 1;
		}
	}

	// <CTRL-C> ̃`FbNIt
	stat_break = get_break();
	set_break( 0 );


	// `FbN
	check_arg( argc, argv );

	// C[v
	mainloop();

	// <CTRL-C> ̃Xe[^Xɖ߂
	set_break( stat_break );

	// JgfBNgɖ߂
	setdisk( (my_path[0] & 0xdf) - 'A' );
	chdir( my_path );

	// I
	printf( "\n  --- Exit ---\n" );
	return 0;
}

void
check_arg( int argc, char **argv )
{
	int	drive = 0;
	int	i;
	char	*p;

	argv++;
	for( i = 1; i < argc; i++ ){
		p = *argv++;

		if( p[0] != '-' ){
			if( drive < MAX_DRIVE ){
				Table::PtrTable[ drive++ ] -> SetPath( p );
			}
		} else {
			switch( p[1] & 0xdf )
			{
			case 'B':
				Com::PtrCom -> SetBaud( &p[2] );
				break;

			case 'A':
				Table::PtrTable[0] -> SetDosAttrib( &p[2] );
				break;

			case 'F':
				Table::PtrTable[0] -> SetMaxFile( &p[2] );
				break;

			case 'P':
				Com::PtrCom -> SetPara( &p[2] );
				break;

			case 'M':
				Com::PtrCom -> SetMsgOff();
				break;
			}
		}
	}

	// ŵȂhCu̓JgfBNgݒ
	for( i = 0; i < MAX_DRIVE; i++ ){
		Table::PtrTable[i] -> SetTable();
	}

	// fBNg̕\
	printf( "\n  --- [Q] ŏI܂ ---\n" );
	for( i = 0; i < MAX_DRIVE; i++ ){
		printf( " %c|%s\n", i + 'A', Table::PtrTable[i] -> GetPath() );
	}
}

void
mainloop( void )
{
	HANDLE	Handle[16];
	HANDLE	*pH;
	Table	*pT;

	int	command, command2;	// R}h
	int	drive, handle;
	int	kind_cmd;		// R}h̎
	int	code;			// R}h̕Ԃl

	int	code_mark;		// R}h\p
	static char	mark[] = { ' ', 'C', 'R', 'W', 'G', 'P', 'V', 'B',
				'S', 'I', 'D', 'F', 'N', 'K', 'U' };

	int	reg_a;			// P create, open ̂߂ :-(
	char	*p;  			// P create, open ̂߂ :-(
	int	i;

	do{
	// R}h̕
		command = Com::Getc();
		command2 = Com::Getc();

		if( ( command < CMD_CREATE ) || ( command > CMD_DISKFREE ) ){
			kind_cmd = -1;
			if( command == CMD_INIT ){
				kind_cmd = 1; code_mark = 0;
			}
		} else {
			code_mark = command - CMD_CLOSE + 1;

			if( command >= CMD_ATTRIB )
				kind_cmd = 1;	// command2 = hCuԍ
			else
				kind_cmd = 0;	// command2 = nh
		}

	// hCuԍEnh̎擾
		drive = command2;
		switch( kind_cmd )
		{
		case 0:
			if( command2 >= MAX_HANDLE ){
				kind_cmd = -1;
				break;
			}
			pH = &Handle[ command2 ];

			// create, open ͕ʈ :-(
			if( (command == CMD_CREATE) || (command == CMD_OPEN) ){
				p = pH -> PFileName;

				// ڂƂȂ̂łŎM
				Com::Putc( command );
				drive = Com::Getc();
				reg_a = Com::Getc();
				for( i = 0; i < 11; i++ ) p[i] = Com::Getc();

				code_mark = 0;
			} else {
				drive = pH -> PDrive;
				handle = pH -> DHandle;
			}

		case 1:
			if( drive >= MAX_DRIVE ) kind_cmd = -1;
		}

		if( kind_cmd == -1 ){
			//printf( "\n [ Unknown Command ]" %02XH %02XH\n",
			//	command, command2 );
			putchar( '@' );
			continue;
		}
		pT = Table::PtrTable[ drive ];

	// R}h̎s
		if( Com::PtrCom -> GetMsgOff() == FALSE ){
			putchar( mark[ code_mark ] );
		}
		switch( command )
		{
		case CMD_CREATE:
			code = pT -> CmdCreate( reg_a, pH );
			break;

		case CMD_OPEN:
			code = pT -> CmdOpen( reg_a, pH );
			break;

		case CMD_CLOSE:
			code = pT -> CmdClose( pH );
			break;

		case CMD_READ:
			code = pT -> CmdRead( handle, command );
			break;

		case CMD_WRITE:
			code = pT -> CmdWrite( handle );
			break;

		case CMD_GETC:
			code = pT -> CmdGetc( handle, command );
			break;

		case CMD_PUTC:
			code = pT -> CmdPutc( handle );
			break;

		case CMD_VERIFY:
			code = pT -> CmdRead( handle, command );
			break;

		case CMD_GETC2:
			code = pT -> CmdGetc( handle, command );
			break;

		case CMD_SEEK:
			code = pT -> CmdSeek( handle );
			break;

		case CMD_INFO:
			code = pT -> CmdInfo( pH );
			break;

		case CMD_ATTRIB:
			code = pT -> CmdAttrib();
			break;

		case CMD_FILES:
			code = pT -> CmdFiles();
			break;

		case CMD_RENAME:
			code = pT -> CmdRename();
			break;

		case CMD_DELETE:
			code = pT -> CmdDelete();
			break;

		case CMD_DISKFREE:
			code = pT -> CmdDiskFree();
			break;

		case CMD_INIT:
			code = pT -> CmdInit();
			break;
		}

		if( code == -1 ){
			if( Com::PtrCom -> GetMsgOff() == FALSE ){
				printf( "\n!\n" );
			}
			Com::Putc( ERROR_CODE );
		}

	} while( Com::PtrCom -> GetDone() == FALSE );
}

void
set_break( char c )
{
	REGS	regs;

	regs.x.ax = 0x3301;	// <CTRL-C> Xe[^X̐ݒ
	regs.h.dl = c;		// Xe[^X

	intdos( &regs, &regs );
}

char
get_break( void )
{
	REGS	regs;

	regs.x.ax = 0x3300;	// <CTRL-C> Xe[^X̎擾
	intdos( &regs, &regs );

	return regs.h.dl;
}

