#include  <stdio.h>
#include  <sys/stat.h>
#include  <utime.h>
#include  <time.h>


/*  DIR Ggɂ^CX^v֘A萔     */
#define  TIME_LL 0x16
#define  TIME_HH 0x17
#define  DATE_LL 0x18
#define  DATE_HH 0x19

#define  YEAR_MASK  0xfe00
#define  YEAR_SHIFT 9
#define  MON_MASK   0x01e0
#define  MON_SHIFT  5
#define  DAY_MASK   0x001f

#define  HOUR_MASK  0xf800
#define  HOUR_SHIFT 11
#define  MIN_MASK   0x07e0
#define  MIN_SHIFT  5
#define  SEC_MASK  0x001f


int get_filetime(char *fullpathname,
				 unsigned int *dateword, unsigned int *timeword)
{
	struct stat fstat;
	struct tm *tm;
	stat(fullpathname, &fstat);
	
#ifndef UNIX
	tm = localtime(&(fstat.st_mtimespec.ts_sec));
#else
	tm = localtime(&(fstat.st_mtime));
#endif
	*timeword = (tm->tm_hour << HOUR_SHIFT);
	*timeword += (tm->tm_min << MIN_SHIFT);
	*timeword += tm->tm_sec / 2;
	*dateword = (tm->tm_year - 80) << YEAR_SHIFT;
	*dateword += ((tm->tm_mon + 1) << MON_SHIFT);
	*dateword += tm->tm_mday;

	return 0;
}


int set_filetime(char *fullpathname,
				 unsigned int dateword, unsigned int timeword)
{
	struct tm *tms;
	struct utimbuf filetimebuf;
	time_t filetime_sec;


	filetime_sec = time(&filetime_sec);
	tms = localtime(&filetime_sec);

	tms->tm_sec = (timeword & SEC_MASK) * 2;
	tms->tm_min = (timeword & MIN_MASK) >> MIN_SHIFT;
	tms->tm_hour= (timeword & HOUR_MASK)>> HOUR_SHIFT;
	tms->tm_mday= (dateword & DAY_MASK);
	tms->tm_mon = ((dateword & MON_MASK) >> MON_SHIFT) - 1;
	tms->tm_year= ((dateword & YEAR_MASK)>> YEAR_SHIFT) + 80;

/*  if((dateword == 0) && (timeword == 0)){  */
	if((tms->tm_year == 80) &&
	   ((tms->tm_mon + 1) == 0) &&
	   (tms->tm_mday == 0)){
		printf("\nĂȂƎv^CX^v %02d/%02d/%02d %02d:%02d:%02d ́Af܂B\n",
						  tms->tm_year, tms->tm_mon + 1, tms->tm_mday,
						  tms->tm_hour, tms->tm_min, tms->tm_sec);
		return 1;
	}

	if((filetime_sec = mktime(tms)) != -1){
		filetimebuf.actime = filetime_sec;
		filetimebuf.modtime= filetime_sec;

		if(utime(fullpathname, &filetimebuf) == 0){
			printf("\nt@C̃^CX^v %02d/%02d/%02d %02d:%02d:%02d ɃZbg܂B\n",
						  tms->tm_year, tms->tm_mon + 1, tms->tm_mday,
						  tms->tm_hour, tms->tm_min, tms->tm_sec);
			return 0;
		}
		else{
			printf("\nt@C̃^CX^v %02d/%02d/%02d %02d:%02d:%02d ɃZbgł܂łB\n",
					  tms->tm_year, tms->tm_mon + 1, tms->tm_mday,
					  tms->tm_hour, tms->tm_min, tms->tm_sec);
			return -1;
		}
	}
	else{
		printf("\n^CX^v𓾂܂łB(%02d/%02d/%02d %02d:%02d:%02d)\n",
						  tms->tm_year, tms->tm_mon + 1, tms->tm_mday,
						  tms->tm_hour, tms->tm_min, tms->tm_sec);
		return -1;
	}
}
